Loading...
Searching...
No Matches
BALL::VIEW::DisplayProperties Class Reference
Visualisation » QT Dialogs

`#include <BALL/VIEW/DIALOGS/displayProperties.h>`

Inheritance diagram for BALL::VIEW::DisplayProperties:

## Public Member Functions

Constructors and Destructors
| DisplayProperties (QWidget *parent=NULL, const char *name="DisplayProperties")
| DisplayProperties (const DisplayProperties &dp)
| Copy constructor just implemented for Python Interface, dont use it!
virtual | ~DisplayProperties ()
Accessors: inspectors and mutators
virtual void | onNotify (Message *message)
virtual void | initializeWidget (MainControl &main_control)
virtual void | initializePreferencesTab (Preferences &preferences)
| Insert the ModelSettingsDialog and the ColoringSettingsDialog into the Preferences.
virtual void | finalizePreferencesTab (Preferences &preferences)
| Remove the ModelSettingsDialog and the ColoringSettingsDialog from the Preferences.
void | applyPreferences ()
virtual void | checkMenu (MainControl &main_control)
void | createRepresentationMode ()
| Switch to the mode, that a new Representation will be created.
void | modifyRepresentationMode (Representation *rep)
| Switch to the mode, that an existing Representation will be modified.
bool | getSettingsFromString (const String &data)
| Settings from String.
void | createRepresentation (String data_string, const vector< const Composite * > &new_systems)
void | enableCreationForNewMolecules (bool state)
| Set if Representations are automaticaly created for new Molecules.
Representation * | getRepresentation ()
| Get the Representation on which DisplayProperties is working on.
virtual Representation * | createRepresentation (const std::list< Composite * > &composites, bool hidden=false)
void | setModelSettingsDialog (ModelSettingsDialog *dialog)
void | setColoringSettingsDialog (ColoringSettingsDialog *dialog)
Public Member Functions inherited from BALL::VIEW::ModularWidget
| ModularWidget (const char *name="<ModularWidget>")
| ModularWidget (const ModularWidget &widget)
virtual | ~ModularWidget ()
virtual void | destroy ()
virtual void | clear ()
QAction * | insertMenuEntry (Position parent_id, const QString &name, const QObject *receiver=0, const char *slot=0, const String &description="", QKeySequence accel=QKeySequence(), const QString &menu_hint=QString(""), UIOperationMode::OperationMode minimal_mode=UIOperationMode::MODE_ALL)
BALL_DEPRECATED void | setMenuHelp (QAction *, const String &)
virtual BALL_DEPRECATED void | registerForHelpSystem (const QObject *, const String &)
virtual void | addToolBarEntries (QToolBar *main_tb)
void | setIcon (QAction *action, const String &filename, bool add_to_main_toolbar=true)
virtual void | fetchPreferences (INIFile &inifile)
virtual void | writePreferences (INIFile &inifile)
bool | lockComposites ()
bool | unlockComposites ()
| Unlock the Composites.
MainControl * | getMainControl () const
virtual void | setStatusbarText (const String &text, bool important=false)
virtual void | setStatusbarText (const QString &text, bool important=false)
String | getWorkingDir ()
| Implemented for convenience.
void | setWorkingDir (const String &dir)
| Implemented for convenience.
FragmentDB & | getFragmentDB () const
virtual void | dump (std::ostream &s=std::cout, Size depth=0) const
void | setWorkingDirFromFilename_ (String filename)
virtual BALL_DEPRECATED void | showHelp (const String &)
virtual void | finalizeWidget (MainControl &main_control)
virtual bool | canHandle (const String &) const
virtual bool | openFile (const String &)
Public Member Functions inherited from BALL::Embeddable
| Embeddable (const String &identifier="<Embeddable>")
| Embeddable (const Embeddable &embeddable)
virtual | ~Embeddable ()
void | setIdentifier (const String &identifier)
const String & | getIdentifier () const
void | unregisterThis ()
virtual void | registerThis ()
Public Member Functions inherited from BALL::VIEW::ConnectionObject
| ConnectionObject ()
virtual | ~ConnectionObject ()
void | registerConnectionObject (ConnectionObject &object)
void | unregisterConnectionObject (ConnectionObject &object)
bool | isConnectionObjectRegistered (const ConnectionObject &object)
ConnectionObject * | getParent () const
ConnectionObject * | getRoot ()
virtual bool | isValid () const
Public Member Functions inherited from BALL::VIEW::PreferencesEntry
| PreferencesEntry ()
virtual | ~PreferencesEntry ()
virtual void | writePreferenceEntries (INIFile &inifile)
| Store the settings of all registered objects.
virtual void | readPreferenceEntries (const INIFile &inifile)
| Restore the settings of all registered objects.
void | setINIFileSectionName (const String &name)
| Set the name for the section in the INIFile.
const String & | getINIFileSectionName () const
| Get the name for the section in the INIFile.
void | setWidgetStackName (const String &name)
StackPages & | getStackPages ()
| Return all pages, that are to be shown in a parent QStackedWidget.
void | setWidgetStack (QStackedWidget *stack)
virtual void | showStackPage (Position nr)
| Show the specified page in the QStackedWidget.
virtual void | showStackPage (QWidget *widget)
| Show the specified page in the QStackedWidget.
virtual Position | currentStackPage () const
| Get the currently shown page in the QStackedWidget.
virtual void | restoreDefaultValues (bool all=false)
| Set all registered objects to their default values.
virtual void | storeValues ()
virtual void | restoreValues (bool all=false)
virtual void | dump (std::ostream &s=std::cout, Size depth=0) const
virtual bool | setValueAllowed (QObject *)
| Allows to prevent restoring of widgets.

## Public slots

ModelSettingsDialog * | model_settings_
ColoringSettingsDialog * | coloring_settings_
Preferences * | preferences_
QAction * | id_
QPushButton * | create_button_
Representation * | rep_
ColorRGBA | custom_color_
bool | advanced_options_modified_
bool | create_representations_for_new_molecules_
bool | changed_selection_color_
const ModelInformation * | model_information_
void | show ()
void | selectModel (int index)
void | selectMode (int index)
void | selectColoringMethod (int index)
void | setSurfaceDrawingPrecision (float value)
void | setDrawingPrecision (int value)
void | setTransparency (int value)
void | setCustomColor (const ColorRGBA &color)
virtual void | apply ()
void | editSelectionColor (QColor color)
void | coloringOptionsPressed ()
void | modelOptionsPressed ()
void | precisionBoxChanged (int index)
void | transparencySliderChanged ()
void | precisionSliderChanged ()
void | coloringUpdatesChanged ()
void | modelUpdatesChanged ()
void | checkDrawingPrecision_ ()
virtual void | getAdvancedModelOptions_ ()
virtual void | getAdvancedColoringOptions_ ()
virtual void | applyModelSettings_ (Representation &rep)
virtual void | applyColoringSettings_ (Representation &rep)
void | applyTo_ (Representation *rep)

## Additional Inherited Members

Public Types inherited from BALL::Embeddable
typedef std::vector< Embeddable * > | EmbeddableVector
Public Types inherited from BALL::VIEW::PreferencesEntry
typedef std::list< std::pair< QWidget *, String > > | StackPages
static void | registerWidget (ModularWidget *mwidget)
Protected Types inherited from BALL::VIEW::PreferencesEntry
typedef HashMap< const QObject *, String > | ValueMap
void | notify_ (Message *message)
void | notify_ (Message &message)
void | onNotify_ (Message *message)
Protected Member Functions inherited from BALL::VIEW::PreferencesEntry
void | registerWidgets_ ()
void | registerObject_ (QObject *widget)
void | unregisterObject_ (QObject *widget)
BALL_DEPRECATED void | registerWidgetForHelpSystem_ (const QWidget *, const String &)
void | restoreValues_ (bool all, const ValueMap &map)
void | insertStackEntry_ (QWidget *, const String &name)
bool | isSupported_ (QObject &widget)
bool | getValue_ (const QObject *widget, String &value)
bool | setValue_ (QObject *widget, const String &value)
static void | registerInstance_ (const std::type_info &type, const Embeddable *instance)
static void | unregisterInstance_ (const Embeddable *instance)
static Size | countInstances_ (const std::type_info &type)
static Embeddable * | getInstance_ (const std::type_info &type, Position index)
static Embeddable * | getInstance_ (const std::type_info &type, const String &identifier)
QAction * | window_menu_entry_
bool | show_window_enty_
bool | default_visible_
QList< QAction * > | main_toolbar_actions_
Protected Attributes inherited from BALL::VIEW::PreferencesEntry
String | inifile_section_name_
HashSet< QObject * > | registered_objects_
ValueMap | default_values_
ValueMap | last_values_
QStackedWidget * | widget_stack_
StackPages | stack_pages_

## Detailed Description

Dialog for creating and changing representations for a selection of molecular objects. It can create a new Representation for a selection of Composite 's from the MolecularControl. If a Representation is selected in the GeometricControl, it can be modified with this dialog. With the help of various combo boxes it is possible to customize the look of the graphical visualization (the model, the drawing precision, the drawing mode, the coloring method and the custom color). For information about the drawing precision see Representation.
If this dialog is used, it should be created with MainControl as parent.
If you want to add a new coloring method or type of Representation, have a look at VIEW/KERNEL/common.h.

Definition at line 54 of file displayProperties.h.

## Constructor & Destructor Documentation

## DisplayProperties() [1/2]

BALL::VIEW::DisplayProperties::DisplayProperties | ( | QWidget * | parent = NULL,
|  | const char * | name = "DisplayProperties" )

Default Constructor. Calls ModularWidget::registerWidget.

## DisplayProperties() [2/2]

BALL::VIEW::DisplayProperties::DisplayProperties | ( | const DisplayProperties & | dp | ) |

Copy constructor just implemented for Python Interface, dont use it!

## ~DisplayProperties()

virtual BALL::VIEW::DisplayProperties::~DisplayProperties | ( |  | ) |

virtual

Destructor

## Member Function Documentation

## apply

virtual void BALL::VIEW::DisplayProperties::apply | ( |  | ) |

virtual slot

Indicates the apply button was pressed. Applies the selected model with its selected properties to the selected Composite objects or modifies an existing Representation. A SceneMessage will be sent to inform the Scene. A RepresentationMessage notifies the GeometricControl.

## applyColoringSettings_()

virtual void BALL::VIEW::DisplayProperties::applyColoringSettings_ | ( | Representation & | rep | ) |

protected virtual

## applyModelSettings_()

virtual void BALL::VIEW::DisplayProperties::applyModelSettings_ | ( | Representation & | rep | ) |

protected virtual

## applyPreferences()

void BALL::VIEW::DisplayProperties::applyPreferences | ( |  | ) |

virtual

Apply the preferences of the specific tab. In this method the widget can extract any changed values from its preferences tab (if required). This method is called automatically by the applyPreferencesTab from the MainControl object if the apply button in the Preferences dialog is pressed.

Parameters

  preferences | the Preferences dialog of the MainControl

See also
  initializePreferencesTab
  finalizePreferencesTab
  applyPreferencesTab

Reimplemented from BALL::VIEW::ModularWidget.

## applyTo_()

void BALL::VIEW::DisplayProperties::applyTo_ | ( | Representation * | rep | ) |

protected

## checkDrawingPrecision_()

void BALL::VIEW::DisplayProperties::checkDrawingPrecision_ | ( |  | ) |

protected

## checkMenu()

virtual void BALL::VIEW::DisplayProperties::checkMenu | ( | MainControl & | main_control | ) |

virtual

Menu checking method. This method is called by MainControl::checkMenus before a popup menu is shown. The menu entry Display Properties will be checked if this dialog is visible.

Parameters

  main_control | the MainControl object whose menus should be checked

Reimplemented from BALL::VIEW::ModularWidget.

## coloringOptionsPressed

void BALL::VIEW::DisplayProperties::coloringOptionsPressed | ( |  | ) |

slot

## coloringUpdatesChanged

void BALL::VIEW::DisplayProperties::coloringUpdatesChanged | ( |  | ) |

slot

## createRepresentation() [1/2]

virtual Representation * BALL::VIEW::DisplayProperties::createRepresentation | ( | const std::list< Composite * > & | composites,
|  | bool | hidden = false )

virtual

## createRepresentation() [2/2]

void BALL::VIEW::DisplayProperties::createRepresentation | ( | String | data_string,
|  | const vector< const Composite * > & | new_systems )

## createRepresentationMode()

void BALL::VIEW::DisplayProperties::createRepresentationMode | ( |  | ) |

Switch to the mode, that a new Representation will be created.

## editSelectionColor

void BALL::VIEW::DisplayProperties::editSelectionColor | ( | QColor | color | ) |

slot

Opens the color dialog for the color of selected items.

See also
  BALL_SELECTED_COLOR

## enableCreationForNewMolecules()

void BALL::VIEW::DisplayProperties::enableCreationForNewMolecules | ( | bool | state | ) |

inline

Set if Representations are automaticaly created for new Molecules.

Definition at line 142 of file displayProperties.h.

## finalizePreferencesTab()

virtual void BALL::VIEW::DisplayProperties::finalizePreferencesTab | ( | Preferences & | preferences | ) |

virtual

Remove the ModelSettingsDialog and the ColoringSettingsDialog from the Preferences.

Reimplemented from BALL::VIEW::ModularWidget.

## getAdvancedColoringOptions_()

virtual void BALL::VIEW::DisplayProperties::getAdvancedColoringOptions_ | ( |  | ) |

protected virtual

## getAdvancedModelOptions_()

virtual void BALL::VIEW::DisplayProperties::getAdvancedModelOptions_ | ( |  | ) |

protected virtual

## getRepresentation()

Representation * BALL::VIEW::DisplayProperties::getRepresentation | ( |  | ) |

inline

Get the Representation on which DisplayProperties is working on.

Definition at line 146 of file displayProperties.h.

## getSettingsFromString()

bool BALL::VIEW::DisplayProperties::getSettingsFromString | ( | const String & | data | ) |

Settings from String.

## initializePreferencesTab()

virtual void BALL::VIEW::DisplayProperties::initializePreferencesTab | ( | Preferences & | preferences | ) |

virtual

Insert the ModelSettingsDialog and the ColoringSettingsDialog into the Preferences.

Reimplemented from BALL::VIEW::ModularWidget.

## initializeWidget()

virtual void BALL::VIEW::DisplayProperties::initializeWidget | ( | MainControl & | main_control | ) |

virtual

ModularWidget methods Initialize the popup menu Display with the entry Display Properties, which opens the dialog. This method is called automatically immediately before the main application is started by MainControl::show()

Parameters

  main_control | the MainControl object to be initialized

Reimplemented from BALL::VIEW::ModularWidget.

## modelOptionsPressed

void BALL::VIEW::DisplayProperties::modelOptionsPressed | ( |  | ) |

slot

## modelUpdatesChanged

void BALL::VIEW::DisplayProperties::modelUpdatesChanged | ( |  | ) |

slot

## modifyRepresentationMode()

void BALL::VIEW::DisplayProperties::modifyRepresentationMode | ( | Representation * | rep | ) |

Switch to the mode, that an existing Representation will be modified.

## onNotify()

virtual void BALL::VIEW::DisplayProperties::onNotify | ( | Message * | message | ) |

virtual

Message handling method. Handles messages sent by other registered ConnectionObject objects. If a CompositeMessage with type NEW_MOLECULE is catched, the chosen graphical visualization will be applied to the Composite object and the follwing Message objects will be sent through the ConnectionObject tree:

- CompositeMessage with type CENTER_CAMERA
- RepresentationMessage with type NEW
  Parameters

    message | the pointer to the message that should be processed

Reimplemented from BALL::VIEW::ConnectionObject.

## precisionBoxChanged

void BALL::VIEW::DisplayProperties::precisionBoxChanged | ( | int | index | ) |

slot

## precisionSliderChanged

void BALL::VIEW::DisplayProperties::precisionSliderChanged | ( |  | ) |

slot

## selectColoringMethod

void BALL::VIEW::DisplayProperties::selectColoringMethod | ( | int | index | ) |

slot

Changes the coloring method. This slot is connected to the coloring method combo box and will be automatically called if the content of this combo box is changed.

Parameters

  index | the position of the entry in the combobox

## selectMode

void BALL::VIEW::DisplayProperties::selectMode | ( | int | index | ) |

slot

Changes the drawing mode. This slot is connected to the mode combo box and will be automatically called if the content of this combo box is changed.

Parameters

  index | the position of the entry in the combobox

## selectModel

void BALL::VIEW::DisplayProperties::selectModel | ( | int | index | ) |

slot

Changes the model. This slot is connected to the model combo box and will be automatically called if the content of this combo box is changed.

Parameters

  index | the position of the entry in the combobox

## setColoringSettingsDialog()

void BALL::VIEW::DisplayProperties::setColoringSettingsDialog | ( | ColoringSettingsDialog * | dialog | ) |

## setCustomColor

void BALL::VIEW::DisplayProperties::setCustomColor | ( | const ColorRGBA & | color | ) |

slot

## setDrawingPrecision

void BALL::VIEW::DisplayProperties::setDrawingPrecision | ( | int | value | ) |

slot

## setModelSettingsDialog()

void BALL::VIEW::DisplayProperties::setModelSettingsDialog | ( | ModelSettingsDialog * | dialog | ) |

## setSurfaceDrawingPrecision

void BALL::VIEW::DisplayProperties::setSurfaceDrawingPrecision | ( | float | value | ) |

slot

## setTransparency

void BALL::VIEW::DisplayProperties::setTransparency | ( | int | value | ) |

slot

## show

void BALL::VIEW::DisplayProperties::show | ( |  | ) |

slot

Starts the dialog. Calls QDialog::raise().

## transparencySliderChanged

void BALL::VIEW::DisplayProperties::transparencySliderChanged | ( |  | ) |

slot

## Member Data Documentation

## advanced_options_modified_

bool BALL::VIEW::DisplayProperties::advanced_options_modified_

protected

Definition at line 283 of file displayProperties.h.

## changed_selection_color_

bool BALL::VIEW::DisplayProperties::changed_selection_color_

protected

Definition at line 285 of file displayProperties.h.

## coloring_settings_

ColoringSettingsDialog* BALL::VIEW::DisplayProperties::coloring_settings_

protected

Definition at line 272 of file displayProperties.h.

## create_button_

QPushButton* BALL::VIEW::DisplayProperties::create_button_

protected

Definition at line 277 of file displayProperties.h.

## create_representations_for_new_molecules_

bool BALL::VIEW::DisplayProperties::create_representations_for_new_molecules_

protected

Definition at line 284 of file displayProperties.h.

## custom_color_

ColorRGBA BALL::VIEW::DisplayProperties::custom_color_

protected

Definition at line 282 of file displayProperties.h.

## id_

QAction* BALL::VIEW::DisplayProperties::id_

protected

Definition at line 276 of file displayProperties.h.

## model_information_

const ModelInformation* BALL::VIEW::DisplayProperties::model_information_

protected

Definition at line 286 of file displayProperties.h.

## model_settings_

ModelSettingsDialog* BALL::VIEW::DisplayProperties::model_settings_

protected

Definition at line 271 of file displayProperties.h.

## preferences_

Preferences* BALL::VIEW::DisplayProperties::preferences_

protected

Definition at line 273 of file displayProperties.h.

## rep_

Representation* BALL::VIEW::DisplayProperties::rep_

protected

Definition at line 280 of file displayProperties.h.